//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  EXE܂DLL32rbg64rbg𔻒 - PEwb_擾
//  ImageHlp.pasImageNtHeader֐Ńwb_̃|C^擾@
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N0523 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    InitDir : String;
    function GetFileHeaderInfo(FileHandle: THandle): Boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses ImageHlp;

{$R *.dfm}

//=============================================================================
//  tH[̏
//  VXetH_擾邽߂ɁC
//  t@CVXẽ_CNg@\𖳌ɂĂ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  Wow64DisableProc : function(var flgRedirec: LongBool): LongBool; stdcall;
  DirectFlag : LongBool;
begin
  @Wow64DisableProc := GetProcAddress(GetModuleHandle('Kernel32.dll'),
                                      'Wow64DisableWow64FsRedirection');
  if @Wow64DisableProc <> nil then begin
    Wow64DisableProc(DirectFlag);
  end;
end;

//=============================================================================
//  EXE܂DLL32rbg64rbg𔻒 - PEwb_擾
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  FileFullPath : String;
  FileHandle   : THandle;
begin
  if InitDir = EmptyStr then begin
    InitDir := ExtractFileDir(Application.ExeName);
  end;

  OpenDialog1.InitialDir := InitDir;
  OpenDialog1.Filter     := 't@C|*.exe;*.dll';

  if OpenDialog1.Execute then begin
    FileFullPath := OpenDialog1.FileName;
    InitDir      := ExtractFileDir(FileFullPath);

    Memo1.Clear;
    Memo1.Lines.BeginUpdate;

    FileHandle := CreateFile(PChar(FileFullPath),
                             GENERIC_READ,
                             FILE_SHARE_READ,
                             nil,
                             OPEN_EXISTING,
                             FILE_ATTRIBUTE_NORMAL,
                             0);
    if FileHandle = INVALID_HANDLE_VALUE then exit;
    try
      GetFileHeaderInfo(FileHandle);
    finally
      CloseHandle(FileHandle);
    end;
    Memo1.Lines.EndUpdate;
  end;
end;

//-----------------------------------------------------------------------------
//  PEwb_EXEDLL32rbgł64rbgł𒲂ׂ
//  ImageHlp.pasImageNtHeader֐Ńwb_̃|C^擾@
//  ̂߂ɁCt@CnhɂĂ
//-----------------------------------------------------------------------------
function TForm1.GetFileHeaderInfo(FileHandle: THandle): Boolean;
const
  IMAGE_FILE_MACHINE_IA64       = $0200;
  IMAGE_FILE_MACHINE_AMD64      = $8664;
  IMAGE_NT_OPTIONAL_HDR32_MAGIC = $010B;
  IMAGE_NT_OPTIONAL_HDR64_MAGIC = $020B;
var
  HeaderHandle    : THandle;
  HeaderPointer   : Pointer;
  NTHeaders       : PImageNtHeaders;
  Characteristics : Integer;
  MajorVer        : String;
  MinorVer        : String;
  Magic           : WORD;
  Subsystem       : WORD;
begin
  Result := False;

  //}bvht@C
  //t@Cnht@C̃}bsOIuWFNg擾
  HeaderHandle := CreateFileMapping(FileHandle, nil, PAGE_READONLY, 0, 0, nil);
  if HeaderHandle = 0 then exit;
  try
    //}bvht@CAhXԂɃ}bv
    //߂l͊JnAhX
    HeaderPointer := MapViewOfFile(HeaderHandle, FILE_MAP_READ, 0, 0, 0);
    if not Assigned(HeaderPointer) then exit;
    try
      //wb_̃|C^擾
      NTHeaders := ImageNtHeader(HeaderPointer);
      if not Assigned(NTHeaders) then exit;

      //PEwb_(EXE,DLLt@C)ł邩mF
      if Trim(String(PAnsiChar(@NTHeaders.Signature))) <> 'PE' then exit;

      
      case NTHeaders.FileHeader.Machine of
        IMAGE_FILE_MACHINE_I386:  Memo1.Lines.Add( ' Intel 386 (x86) or later' );
        IMAGE_FILE_MACHINE_IA64:  Memo1.Lines.Add( ' Intel Itanium' );
        IMAGE_FILE_MACHINE_AMD64: Memo1.Lines.Add( ' AMD 64 (x64)' );
      end;

      Characteristics := NTHeaders.FileHeader.Characteristics;
      if (IMAGE_FILE_DLL and Characteristics) <> 0 then begin
        Memo1.Lines.Add(' DLL file');
      end else
      if (IMAGE_FILE_EXECUTABLE_IMAGE and Characteristics) <> 0 then begin
        Memo1.Lines.Add(' EXE file' );
      end else begin
        Memo1.Lines.Add(' Unknown file');
      end;


      //J[̃o[W
      MajorVer := IntToStr(NTHeaders.OptionalHeader.MajorLinkerVersion);
      MinorVer := IntToStr(NTHeaders.OptionalHeader.MinorLinkerVersion);
      Memo1.Lines.Add(' LinkerVersion : ' + MajorVer + '.' + MinorVer);

      Magic := NTHeaders.OptionalHeader.Magic;
      if (Magic = IMAGE_NT_OPTIONAL_HDR32_MAGIC) then begin
        Memo1.Lines.Add(' IMAGE_NT_OPTIONAL_HDR32_MAGIC');
      end else
      if (Magic = IMAGE_NT_OPTIONAL_HDR64_MAGIC) then begin
        Memo1.Lines.Add(' IMAGE_NT_OPTIONAL_HDR64_MAGIC');
      end;

      Subsystem := NTHeaders.OptionalHeader.Subsystem;
      //R\[AvP[V̏ꍇ
      if Subsystem = IMAGE_SUBSYSTEM_WINDOWS_CUI then begin
        Memo1.Lines.Add(' Subsystem : CONSOLE Application');
      end;
    finally
      UnmapViewOfFile(HeaderPointer);
    end;
  finally
    CloseHandle(HeaderHandle);
  end;
  Result := True;
end;

end.
